function [cs ch]=cov_betagrad(Amat,cl,cnew,g_samp,z_samp,CCnew,nz_pop,nzero_samp,est_old,svec,beta,nsize)
% compute the gradient and the hessian of the approximated log-likelihood wrt beta %
S=CCnew(g_samp,(1:nsize),:);
srsmat=z_samp;
[s1,s2]=size(srsmat);
[~,colsub]=find(srsmat);
rowvec=g_samp(colsub);
colvec=reshape(srsmat,s1*s2,1);
linearInd=sub2ind(size(CCnew(:,:,1)),rowvec,colvec);
clusterInd=sub2ind(size(est_old),cnew(rowvec),cnew(colvec));
est_oldcl=est_old(clusterInd);
est_oldmat=reshape(est_oldcl,s2,s1);
[dim1,dim2,dim3]=size(CCnew);
S1=reshape(CCnew,dim1*dim2,dim3);
S1_trn=S1(linearInd,:);
[d1 d2 d3]=size(S);
S_trn=reshape(S,d1*d2,d3);
Snew=beta'*S_trn';
S1new=beta'*S1_trn';
Snew_trn=reshape(Snew,d1,d2);
S1new_trn=reshape(S1new,s2,s1);



%%%% Computation of the first part of the gradient wrt beta %%%%
M1=Amat(g_samp,(1:nsize)).*(1-(exp(est_old(cnew(g_samp),cnew(1:nsize))+ Snew_trn)./(1+exp(est_old(cnew(g_samp),cnew(1:nsize))+ Snew_trn))));
[dm1,dm2]=size(M1);
M1new=reshape(M1,dm1*dm2,1);
m1= repmat(M1new,1,size(S_trn,2));
Lnew=reshape(full(m1).*S_trn,dm1,dm2,d3);
Ls=squeeze(sum(Lnew(:,:,:),2))';
A1=Ls*svec(cl(g_samp));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%% Computation of the 2nd part of the gradient wrt beta %%%%
M2=exp(est_oldmat + S1new_trn)./(1+exp(est_oldmat + S1new_trn));
[dmm1,dmm2]=size(M2);
M2new=reshape(M2,dmm1*dmm2,1);
m2= repmat(M2new,1,size(S1_trn,2));
Knew=reshape(full(m2).*S1_trn,dmm1,dmm2,d3);
Ks=squeeze(sum(Knew(:,:,:),2))';
A2=Ks*(svec(cl(g_samp)).*(nz_pop(1:length(g_samp))/nzero_samp));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%% Computation of the first part of the hessian wrt beta %%%%%
N1=-Amat(g_samp,(1:nsize)).*exp(est_old(cnew(g_samp),cnew(1:nsize))+ Snew_trn)./(1+exp(est_old(cnew(g_samp),cnew(1:nsize))+ Snew_trn)).^2;
[dn1,dn2]=size(N1);
N1new=reshape(N1,dn1*dn2,1);
jj = 1:d3;
Y = reshape(repmat(S_trn',d3,1) .* S_trn(:,jj(ones(d3, 1),:)).',[d3 d3 d1*d2]);
Y1=Y.*repmat(reshape(full(N1new)',[1 1 length(N1new)]),[d3 d3]);
Pnew=reshape(Y1,d3,d3,dn1,dn2);
Ps=squeeze(sum(Pnew(:,:,:,:),4));
Ps1=Ps.*repmat(reshape(svec(cl(g_samp))',[1 1 length(svec(cl(g_samp)))]),[d3 d3]);
%Ps1=Ps.*svec(cl(g_samp));
D1=squeeze(sum(Ps1(:,:,:),3));
%D1=sum(Ps1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%% Computation of the second part of the hessian wrt beta %%%%
N2=-exp(est_oldmat + S1new_trn)./(1+exp(est_oldmat + S1new_trn)).^2;
[dnn1,dnn2]=size(N2);
N2new=reshape(N2,dnn1*dnn2,1);
Z = reshape(repmat(S1_trn',d3,1) .* S1_trn(:,jj(ones(d3, 1),:)).',[d3 d3 s1*s2]);
Z1=Z.*repmat(reshape(full(N2new)',[1 1 length(N2new)]),[d3 d3]);
Qnew=reshape(Z1,d3,d3,dnn1,dnn2);
Qs=squeeze(sum(Qnew(:,:,:,:),4));
Qs1=Qs.*repmat(reshape((svec(cl(g_samp)).*(nz_pop(1:length(g_samp))/nzero_samp))',[1 1 length(svec(cl(g_samp)))]),[d3 d3]);
%Qs1=Qs.*svec(cl(g_samp)).*(nz_pop(1:length(g_samp))/nzero_samp);
D2=squeeze(sum(Qs1(:,:,:),3));
%D2=sum(Qs1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cs=A1-A2;
ch=D1+D2;
end




