%% Gibbs Sampling for drawing the latent labels in stratified approximate likelihood %%
function lsamp = gibbs_cov(prob_mat,beta,xcov,cl,class_prob,Amat,nz_pop,nzero_samp,z_samp,nsamp_str,g_samp,ksize)
%prob.vector=repmat(class_prob,[1 nsize]);
cnew=cl;

for r =1:2
    for s=1:nsamp_str
        B=find(Amat(g_samp(s),:)==1);
        C=z_samp(:,s);
        C(C==g_samp(s))=[];
        eta1=prob_mat(1:ksize,cnew(B)) + repmat(beta'*reshape(xcov(g_samp(s),B,:),numel(B),numel(beta))',ksize,1);
        eta2=prob_mat(1:ksize,cnew(C)) + repmat(beta'*reshape(xcov(g_samp(s),C,:),numel(C),numel(beta))',ksize,1);
        w_org=sum(eta1,2)-sum(log(1+exp(eta1)),2)-(nz_pop(s)/nzero_samp).*sum(log(1+exp(eta2)),2) + log(class_prob);
        w_scaled=w_org-max(w_org);
        cnew(g_samp(s))=randsample(ksize,1,true,exp(w_scaled));
    end
end
lsamp=cnew;
end