function [chat,thetahat,pri_hat,betahat]=parEM_cov(numgibbs,betavalue,linkmat,covmat,nodelabel,class_prob,Amat,zsamp,subsampvec,sizevec,numsamp,numcon,nz_pop,ksize,nsize)
% Function to calculate the parameter estimates in a covariate blockmodel by Monte-Carlo EM
gradsum=zeros(ksize,ksize);
hesssum=zeros(ksize,ksize);
pi_sum=zeros(ksize,1);
thetalink_cc=zeros(ksize,ksize);
alpha=0.2;% step size
for m=1:numgibbs
    csamp = gibbs_cov(linkmat,betavalue,covmat,nodelabel,class_prob,Amat,nz_pop,numcon,zsamp,numsamp,subsampvec,ksize);
    for u=1:K
        for v=1:K
            if(v>=u)
                [grad1 hess1]=cov_grad(Amat,u,v,nodelabel,csamp,subsampvec,zsamp,covmat,nz_pop,numcon,linkmat,sizevec,betavalue);
                [grad2 hess2]=cov_grad(Amat,v,u,nodelabel,csamp,subsampvec,zsamp,covmat,nz_pop,numcon,linkmat,sizevec,betavalue);
                gradsum(u,v)=gradsum(u,v)+grad1+grad2;
                hesssum(u,v)=hesssum(u,v)+hess1+hess2;
            end
        end
    end
    uv = unique(csamp);
    czero=ismember((1:ksize),uv);
    czero=double(czero);
    hh=histc(csamp,uv)/n;
    czero(czero==1)=hh(1:end)';
    pi_sum =pi_sum + czero';
end
%%%% Newton-Raphson step to estimate the parameters
for u=1:K
    for v=1:K
        if(v>=u)
            thetalink_cc(u,v)=thetalink(u,v)-(alpha*((gradsum(u,v))/(hesssum(u,v))));
        else
            thetalink_cc(u,v)=thetalink_cc(v,u);
        end
    end
end
[gradbeta hessbeta]=cov_betagrad(Amat,nodelabel,csamp,subsampvec,zsamp,covmat,nz_pop,numcon,linkmat,sizevec,betavalue,nsize);
chat=csamp;
thetahat=thetalink_cc;
pri_hat=pi_sum/numgibbs;
betahat=betavalue-(alpha*(hessbeta\gradbeta));
end